【LeetCode】300.最长递增子序列

首先分析这个问题,以示例1为例。

已经求得最大递增子序列长度为4,而且该子序列中最后一个数为101,

那么一定存在一个数ai,使得ai以及ai之前的所有数组成的序列中,

最大递增子序列长度为3,而且该子序列中最后一个数为ai。

我们记dp i 为,从第0个数到第 i-1 个数所组成的序列中,最大递增子序列的长度。那么在示例1中,dp 0 =1;dp 1 =1;dp 2 =1;dp 3 =2;dp 4 =2;dp 5 =3;dp 6 =4;dp 7 =4.

示例2中,dp 0 =1;dp 1 =2;dp 2 =2;dp 3 =3;dp 4 =3;dp 5 =4.

可以看出dp i 的值是依次以某种规律递增的。

但由于要求是严格递增的子序列,因此ai之前比ai大的数就不再纳入考虑。

综上所述,dp i 的值可以这么确定:找到ai之前比它小的数ak,dp i =dp k +1,最后为了使dpi最大,就必须使dp k 最大,因此要在ai之前的数里找到最大的dp k ,由此就得到了dp i 。

cpp 复制代码
class Solution {
public:
    int lengthOfLIS(vector<int>& nums) {
        int dp[2510]={0};
        int len=nums.size();
        for(int i=0;i<len;++i)
        {
            dp[i]=1;
//子序列长度最小值是 1
            for(int j=0;j<i;++j)
//第二层循环的目的是找到nums[i]之前比它小的数nums[j],
//找到最大值dp[j]之后,dp[i]=dp[j]+1
//下面这种写法等效于上面的分析,不过省了一点代码
            {
                if(nums[j]<nums[i])
                dp[i]=max(dp[i],dp[j]+1);
            }
        }
        int MAX=0;
        for(int i=0;i<len;++i) MAX=max(MAX,dp[i]);
//这里需要遍历整个dp数组找出最大值,原因在下面
        return MAX;
    }
};

需要注意的是:这种方法最后需要遍历一遍dp数组来找出最大值,因为如果给出的序列如下:

元素:1,3,6,7,9,4,10,5,6

编号:0 1 2 3 4 5 6 7 8

那么dp 6 =6,但是计算dp 5 时,由于6、7、9都比4大,因此只考虑了dp 5 =max(dp 5 ,dp 1 +1),而dp 1 =2,故dp 5 =3;这就导致计算dp 7 =max(dp 7 ,dp 5 +1)=4,同理dp8=5,如果直接输出dp len ,就错了。

相关推荐
生态学者3 小时前
Global Change Biology | 森林越“步调一致”,反而越怕干旱?树木生长与叶片活动的同步之谜
大数据·人工智能·算法·r语言·微信公众平台
lsswear3 小时前
Agent 框架新手入门与实战部署指南
大数据·人工智能·算法
Data analyse4565 小时前
rnweb 回放数据量太大怎么办?分片存储与断点续传的实现思路
前端·网络·算法·数据分析
Navigator_Z6 小时前
LeetCode //C - 1293. Shortest Path in a Grid with Obstacles Elimination
c语言·算法·leetcode
Nil2087 小时前
leetcode 64最小路径和
算法·leetcode·职场和发展
光影少年7 小时前
AI Agent、自动化与未来工作
人工智能·算法·架构
牧羊人.3337 小时前
计算机视觉基础 第16章|EigenFace,FisherFace,LBPH传统人脸识别算法
人工智能·算法·计算机视觉
Nil2087 小时前
leetcode 72编辑距离
算法·leetcode·职场和发展
神工坊7 小时前
技术分享︱SIMFORGE HSF® 网格加密与热点加速技术实践
算法·hpc·网格·cae·工程仿真·数值引擎·samr
Nil2088 小时前
leetcode 136只出现一次的数字
leetcode·哈希算法·散列表